/*	
	dashSense 0.1.7
	
	Author: Paolo Grifantini 2008-07-30
	Contact: pagri@tele2.it
	
	This work is licensed under a Creative Commons License
	http://creativecommons.org/licenses/by-nc-sa/2.0/
	
	Attribution-NonCommercial-NoDerivative 2.0
	
	You are free:
	* to copy, distribute and display the work
	
	Under the following conditions:
	* Attribution. You must give the original author credit.
	* Noncommercial. You may not use this work for commercial purposes.
	* No derivative works allowed.
	
	* For any reuse or distribution, you must make clear to others the license terms of this work.
	* Any of these conditions can be waived if you get permission from the copyright holder.
	
	* The code in the file adsense.php is released under the terms of the GNU General Public License as published by the Free Software Foundation
	
*/

/* ********** to do ****************

possibili errori: file localizzato quindi letto male; timeout di connessione; credenziali errate; sito temporaneamente fuori servizio

*/

localizedStrings["attribution_label"]  = 'v0.1.7, by Paolo Grifantini';

var current_version = "0.1.7";
var there_is_a_new_version = false;

var throbber_visibile = 0;
var error_state = false; // all'inizio non siamo in errore
var updating = false;

var password_changed = false;
var first_time = false;
var prefs_changed = false;

var last_update;

var mode_selected = 0; // daily

var username = "";
var password = "";

function load()
{
    last_update = new Date();
	last_update = last_update.setDate(last_update.getDate()-1); // yesterday by default so it does not create problems
    
    setupParts();
	
	content=document.getElementById('front');
	
	first_time = widget.preferenceForKey("first_time");
	if (isNotInizialized(first_time)) {first_time = true;} else {first_time = (first_time == "true")?true:false}
	
	content.addEventListener('mousemove',mousemove,false);
	content.addEventListener('mouseout',mouseexit,false);
	
	document.getElementById('update_data').style.opacity = "0.0";
	update_data.setAttribute ("onmouseup", "javascript:force_update_data();");
	
	separators = KeychainPlugin.getSeparators();
	thousand_separator = separators.charAt(0);
	decimal_separator = separators.charAt(1);
	
	mode_selected = widget.preferenceForKey("mode_selected");
	if (isNotInizialized(mode_selected)) {mode_selected = 0;} else {mode_selected = parseInt(mode_selected);}
	document.getElementById("mode_select").options[mode_selected].selected = true;
	set_mode();
	
	displayed_total = widget.preferenceForKey("last_total");
	displayed_daily = widget.preferenceForKey("last_daily");
	
	displayed_all_data = widget.preferenceForKey("last_all_data");
	if (!isNotInizialized(displayed_all_data)) displayed_all_data = displayed_all_data.split(";");
	
	displayed_click_data = widget.preferenceForKey("last_click_data");
	if (!isNotInizialized(displayed_click_data)) displayed_click_data = displayed_click_data.split(";");
	
	displayed_ctr_data = widget.preferenceForKey("last_ctr_data");
	if (!isNotInizialized(displayed_ctr_data)) displayed_ctr_data = displayed_ctr_data.split(";");
	
	setTimeout("version_check();", 20*1000);
	
	show_data();
	
	username = widget.preferenceForKey("username");
	if (isNotInizialized(username)){
		username = "";
		showBack();
		return;
	}
	
	password = getPassword(username);
	
	if (isNotInizialized(password)){
		password = "";
		showBack();
		return;
	}
	
	getData();
}

function show_data()
{
	if (isNotInizialized(displayed_total)) {document.getElementById("todayValue").innerHTML = "---";return;}
	var to_display_total = displayed_total.replace(/\,/,".");
	to_display_total = to_display_total.replace(/\./,decimal_separator);
	if (!isNotInizialized(displayed_total)) {document.getElementById("accumulatedValue").innerHTML = to_display_total + " $";} else {document.getElementById("accumulatedValue").innerHTML = "---";}
	
	
	if (mode_selected == 0){
		if (isNotInizialized(displayed_daily)) {document.getElementById("todayValue").innerHTML = "---";return;}
		var to_display_daily = displayed_daily.replace(/\,/,".");
		to_display_daily = to_display_daily.replace(/\./,decimal_separator);
		if (!isNotInizialized(displayed_daily)) {document.getElementById("todayValue").innerHTML = to_display_daily + " $";} else {document.getElementById("todayValue").innerHTML = "---";}
	} else if (mode_selected == 1){
		if (isNotInizialized(displayed_all_data)) {document.getElementById("todayValue").innerHTML = "---";return;}
		var to_display_yesterday = displayed_all_data[2];
		to_display_yesterday = to_display_yesterday.replace(/\,/,".");
		to_display_yesterday = to_display_yesterday.replace(/\./,decimal_separator);
		
		if (!isNotInizialized(to_display_yesterday)) {document.getElementById("todayValue").innerHTML = to_display_yesterday + " $";} else {document.getElementById("todayValue").innerHTML = "---";}
	} else if (mode_selected == 2){
		if (isNotInizialized(displayed_all_data)) {document.getElementById("todayValue").innerHTML = "---";return;}
		var total_weekly = 0;
		var current_day;
		
		for (var j=1; j<displayed_all_data.length;j++){
			if (j == 8) break;
			try{current_day = displayed_all_data[j].replace(/,/,"."); current_day = parseFloat(current_day);} catch(ex) {break;}
			total_weekly += current_day;
		}
		
		total_weekly = Math.round(total_weekly*100)/100;
		var to_display_total_weekly = total_weekly.toString();
		to_display_total_weekly = to_display_total_weekly.replace(/\./,decimal_separator);
		if (!isNotInizialized(total_weekly)) {document.getElementById("todayValue").innerHTML = to_display_total_weekly + " $";} else {document.getElementById("todayValue").innerHTML = "---";}
	} else if (mode_selected == 3){
		if (isNotInizialized(displayed_all_data)) {document.getElementById("todayValue").innerHTML = "---";return;}
		var total_from_last = 0;
		var current_day;
		var items_added = 0;
		
		for (var j=1; j<displayed_all_data.length;j++){
			try{current_day = displayed_all_data[j].replace(/,/,"."); current_day = parseFloat(current_day);} catch(ex) {break;}
			total_from_last += current_day;
			items_added++;
		}
		
		var average_daily = total_from_last / items_added;
		
		average_daily = Math.round(average_daily*100)/100;
		var to_display_average_daily = average_daily.toString();
		to_display_average_daily = to_display_average_daily.replace(/\./,decimal_separator);
		if (!isNotInizialized(average_daily)) {document.getElementById("todayValue").innerHTML = to_display_average_daily + " $";} else {document.getElementById("todayValue").innerHTML = "---";}
	} else if (mode_selected == 4){
		if (isNotInizialized(displayed_all_data)) {document.getElementById("todayValue").innerHTML = "---";return;}
		var highest_value = 0;
		var current_day;
		
		for (var j=1; j<displayed_all_data.length;j++){
			try{current_day = displayed_all_data[j].replace(/,/,"."); current_day = parseFloat(current_day);} catch(ex) {break;}
			if (current_day >= highest_value) highest_value = current_day;
		}
		
		highest_value = Math.round(highest_value*100)/100;
		var to_display_highest_value = highest_value.toString();
		to_display_highest_value = to_display_highest_value.replace(/\./,decimal_separator);
		if (!isNotInizialized(to_display_highest_value)) {document.getElementById("todayValue").innerHTML = to_display_highest_value + " $";} else {document.getElementById("todayValue").innerHTML = "---";}
	} else if (mode_selected == 5){
		if (isNotInizialized(displayed_click_data)) {document.getElementById("todayValue").innerHTML = "---";return;}
		var click_today = displayed_click_data[1];
		if (!isNotInizialized(click_today)) {document.getElementById("todayValue").innerHTML = click_today;} else {document.getElementById("todayValue").innerHTML = "---";}
	} else if (mode_selected == 6){
		if (isNotInizialized(displayed_click_data)) {document.getElementById("todayValue").innerHTML = "---";return;}
		var total_click_from_last = 0;
		var current_day;
		var items_added = 0;
		
		for (var j=1; j<displayed_all_data.length;j++){
			try{current_day = displayed_click_data[j]; current_day = parseInt(current_day);} catch(ex) {break;}
			total_click_from_last += current_day;
			items_added++;
		}
		
		var average_daily_click = total_click_from_last / items_added;
		
		average_daily_click = Math.round(average_daily_click*100)/100;
		
		var average_daily_click = average_daily_click.toString();
		if (!isNotInizialized(average_daily_click)) {document.getElementById("todayValue").innerHTML = average_daily_click;} else {document.getElementById("todayValue").innerHTML = "---";}
	} else if (mode_selected == 7){
		if (isNotInizialized(displayed_click_data)) {document.getElementById("todayValue").innerHTML = "---";return;}
		var highest_click_value = 0;
		var current_day;
		
		for (var j=1; j<displayed_all_data.length;j++){
			try{current_day = displayed_click_data[j]; current_day = parseInt(current_day);} catch(ex) {break;}
			if (current_day >= highest_click_value) highest_click_value = current_day;
		}
		
		var to_display_highest_value = highest_click_value.toString();
		if (!isNotInizialized(to_display_highest_value)) {document.getElementById("todayValue").innerHTML = to_display_highest_value;} else {document.getElementById("todayValue").innerHTML = "---";}
	} else if (mode_selected == 8){
		if (isNotInizialized(displayed_ctr_data)) {document.getElementById("todayValue").innerHTML = "---";return;}
		var to_display_daily_ctr = displayed_ctr_data[1];
		to_display_daily_ctr = to_display_daily_ctr.replace(/\./,decimal_separator);
		to_display_daily_ctr = to_display_daily_ctr.replace(/\,/,decimal_separator);
		if (!isNotInizialized(to_display_daily_ctr)) {document.getElementById("todayValue").innerHTML = to_display_daily_ctr + "%";} else {document.getElementById("todayValue").innerHTML = "---";}
	} else if (mode_selected == 9){
		if (isNotInizialized(displayed_ctr_data)) {document.getElementById("todayValue").innerHTML = "---";return;}
		var total_from_last = 0;
		var current_day;
		var items_added = 0;
		
		for (var j=1; j<displayed_all_data.length;j++){
			try{current_day = displayed_ctr_data[j].replace(/,/,"."); current_day = parseFloat(current_day);} catch(ex) {break;}
			total_from_last += current_day;
			items_added++;
		}
		
		var average_ctr_daily = total_from_last / items_added;
		
		average_ctr_daily = Math.round(average_ctr_daily*100)/100;
		var to_display_average_daily = average_ctr_daily.toString();
		to_display_average_daily = to_display_average_daily.replace(/\./,decimal_separator);
		if (!isNotInizialized(average_ctr_daily)) {document.getElementById("todayValue").innerHTML = to_display_average_daily + "%";} else {document.getElementById("todayValue").innerHTML = "---";}
	} else if (mode_selected == 10){
		if (isNotInizialized(displayed_ctr_data)) {document.getElementById("todayValue").innerHTML = "---";return;}
		var highest_value = 0;
		
		for (var j=1; j<displayed_all_data.length;j++){
			try{current_day = displayed_ctr_data[j].replace(/,/,"."); current_day = parseFloat(current_day);} catch(ex) {break;}
			if (current_day >= highest_value) highest_value = current_day;
		}
		
		highest_value = Math.round(highest_value*100)/100;
		var to_display_highest_value = highest_value.toString();
		to_display_highest_value = to_display_highest_value.replace(/\./,decimal_separator);
		if (!isNotInizialized(to_display_highest_value)) {document.getElementById("todayValue").innerHTML = to_display_highest_value + "%";} else {document.getElementById("todayValue").innerHTML = "---";}
	} else if (mode_selected == 11){
		if (isNotInizialized(displayed_daily)) {document.getElementById("todayValue").innerHTML = "---";return;}
		if (isNotInizialized(displayed_click_data)) {document.getElementById("todayValue").innerHTML = "---";return;}
		
		var to_display_daily = displayed_daily.replace(/\,/,".");
		var today_value = parseFloat(to_display_daily);
		
		var click_today = parseInt(displayed_click_data[1]);
		
		var average = today_value / click_today;
		
		var to_display_value = Math.round(average*100)/100;
		to_display_value = to_display_value.toString();
		to_display_value = to_display_value.replace(/\./,decimal_separator);
		if (!isNotInizialized(to_display_value)) {document.getElementById("todayValue").innerHTML = to_display_value + " $";} else {document.getElementById("todayValue").innerHTML = "---";}
	} else if (mode_selected == 12){
		if (isNotInizialized(displayed_total)) {document.getElementById("todayValue").innerHTML = "---";return;}
		if (isNotInizialized(displayed_click_data)) {document.getElementById("todayValue").innerHTML = "---";return;}		
		
		var to_display_total = displayed_total.replace(/\,/,".");
		var click_total = displayed_click_data[0];
		
		click_total = click_total.replace(/\,/,"");
		click_total = click_total.replace(/\./,"");
		click_total = click_total.replace(/\s/,""); // all the possible thousand separators
		
		var average = parseFloat(to_display_total)/parseInt(click_total);
				
		average = Math.round(average*100)/100;
		var to_display_average = average.toString();
		to_display_average = to_display_average.replace(/\./,decimal_separator);
		if (!isNotInizialized(to_display_average)) {document.getElementById("todayValue").innerHTML = to_display_average + " $";} else {document.getElementById("todayValue").innerHTML = "---";}
	}
}

function change_mode()
{
	mode_selected = document.getElementById("mode_select").selectedIndex;
	save_mode();
	set_mode();
	
	show_data();
}

function save_mode()
{
	widget.setPreferenceForKey(mode_selected.toString(),"mode_selected");
}

function set_mode()
{
	if (mode_selected == 0){
		document.getElementById("today_label").innerText = getLocalizedString("today_label");
	} else if (mode_selected == 1){
		document.getElementById("today_label").innerText = getLocalizedString("yesterday_label");
	} else if (mode_selected == 2){
		document.getElementById("today_label").innerText = getLocalizedString("this_week");
	} else if (mode_selected == 3){
		document.getElementById("today_label").innerText = getLocalizedString("average");
	} else if (mode_selected == 4){
		document.getElementById("today_label").innerText = getLocalizedString("highest");
	} else if (mode_selected == 5){
		document.getElementById("today_label").innerText = getLocalizedString("daily_click_today");
	} else if (mode_selected == 6){
		document.getElementById("today_label").innerText = getLocalizedString("daily_click_average");
	} else if (mode_selected == 7){
		document.getElementById("today_label").innerText = getLocalizedString("daily_click_highest");
	} else if (mode_selected == 8){
		document.getElementById("today_label").innerText = getLocalizedString("ctr_today");
	} else if (mode_selected == 9){
		document.getElementById("today_label").innerText = getLocalizedString("ctr_average");
	} else if (mode_selected == 10){
		document.getElementById("today_label").innerText = getLocalizedString("ctr_highest");
	} else if (mode_selected == 11){
		document.getElementById("today_label").innerText = getLocalizedString("epc_daily");
	} else if (mode_selected == 12){
		document.getElementById("today_label").innerText = getLocalizedString("epc_average");
	}
}
//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//************ widget core **************************************

function force_update_data()
{
	// eseguo l'update forzato se e solo se sono passati meno di 15 minuti o se c' un errore in corso
	if (updating) return;
	
	var current_time = new Date();
	
	if (error_state){
		try{clearTimeout(nextUpdate);} catch(ex){}
		fetchData();
		return;
	}
	
	if (((current_time.getTime() - last_update.getTime()) < 15*60*1000) && (!updating)) {return;}
	
	// disabilito il prossimo update automatico; lo sto forzando
	try{clearTimeout(nextUpdate);} catch(ex){}
	
	fetchData();
}

function getData()
{
	//devo inviare username e password (prendo quella salvata)
	//se non sono settate
	username = widget.preferenceForKey("username");
	if (isNotInizialized(username)){
		showBack();
		return;
	}
	
	password = getPassword(username);
	
	if (isNotInizialized(password)){
		showBack();
		return;
	}
	
	// eseguo lo script ed ottengo i dati
	fetchData(); // aggiorno i dati ogni ora
}

function fetchData()
{
	updating = true;
	throbber_visibile += 1; // il numero di siti che devo visitare
	
	throb = new Throbber("retrieving");
	retrieving.setAttribute ("style", "display:block;");
	throb.start();
	
	var command=widget.system("./adsense.php " + username + " " + password, displayData);
	command.close();
}

function displayData(data)
{
	throbber_visibile -= 1;
	updating = false;
		
	if (throbber_visibile == 0){throb.stop();retrieving.setAttribute ("style", "display:none;");}
	
	try{
		total_output_data = data.outputString.split("#");
		
		output = total_output_data[0];
		output_click = total_output_data[1];
		output_ctr = total_output_data[2];
		
		//output=data.outputString.split(";");
		output=output.split(";");
		// verifico i dati in output
		var valid_output = true;
		
		for (var j=0;j<output.length;j++){
			output[j] = encodeURI(output[j]);
			output[j] = output[j].replace(/%00/g,"");
			output[j] = output[j].replace(/%22/g,"");
		}
		
		total = output[0];
		daily = output[1];
		
		var m = /[0-9.,]+/.exec(total);
		if ((m != null) && (m[0] = total) && (total.length > 0)) {valid_output = true;} else {valid_output = false;}
		
		var n = /[0-9.,]+/.exec(daily);
		if ((n != null) && (n[0] == daily) && (daily.length > 0)) {valid_output = true;} else {valid_output = false;}
		
		if (valid_output == false) {error_state = true; error_icon.style.display = 'block'; nextUpdate = setTimeout('fetchData();',15*60*1000); return;}
		
		error_icon.style.display = 'none';
		error_state = false;
		// nessun errore, vado avanti
		
		displayed_total = total;
		displayed_daily = daily;
		displayed_all_data = output;
		
		output_click=output_click.split(";");
		
		for (var j=0;j<output_click.length;j++){
			output_click[j] = encodeURI(output_click[j]);
			output_click[j] = output_click[j].replace(/%00/g,"");
			output_click[j] = output_click[j].replace(/%22/g,"");
		}
		
		displayed_click_data = output_click;
		
		output_ctr=output_ctr.split(";");
		
		for (var j=0;j<output_ctr.length;j++){
			output_ctr[j] = encodeURI(output_ctr[j]);
			output_ctr[j] = output_ctr[j].replace(/%00/g,"");
			output_ctr[j] = output_ctr[j].replace(/%22/g,"");
			output_ctr[j] = output_ctr[j].replace(/%25/g,"");
		}
		
		displayed_ctr_data = output_ctr;
		
		show_data();
		
		// li salvo nelle preferenze!
		widget.setPreferenceForKey(displayed_total.toString(),"last_total");
		widget.setPreferenceForKey(displayed_daily.toString(),"last_daily");
		
		widget.setPreferenceForKey(displayed_all_data.join(";"),"last_all_data");
		widget.setPreferenceForKey(displayed_click_data.join(";"),"last_click_data");
		widget.setPreferenceForKey(displayed_ctr_data.join(";"),"last_ctr_data");
		
		// ora salvo il tempo, cos se l'utente forza il refresh verifico che siano passati almeno 15 minuti!
		last_update = new Date();
		// lancio il prossimo update automatico fra 1 ora
		nextUpdate = setTimeout('fetchData();',60*60*1000);
	} catch (ex) {error_state = true; error_icon.style.display = 'block'; nextUpdate = setTimeout('fetchData();',15*60*1000); return;}
}

function getPassword(username)
{	
	var the_password = KeychainPlugin.getPassword(username,"dashSense","default");
	
	if (the_password == "-1") {the_password = "";}
	// ora dovrei ripulire la password
	return the_password;
}

//************ back & prefs & utilities **************************************

function isNotInizialized(the_var)
{
	if (((the_var == undefined) || (the_var == "") || (the_var == "NaN") || (the_var == "undefined") || (the_var == null)) && (the_var != "0")) return true;
	return false;
}

function setPrefs()
{
	document.getElementById("input_username").value = username;
	document.getElementById("input_password").value = password;
}

function savePrefs()
{
	username = document.getElementById("input_username").value;
	widget.setPreferenceForKey(username.toString(),"username");
	
	if (first_time){ // devo creare una entry nel portachiavi
		widget.setPreferenceForKey(first_time.toString(),"first_time");
		first_time = false;
	}
	
	KeychainPlugin.setPassword(username,document.getElementById("input_password").value,"dashSense","default");
	
	password_changed = false;
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
	//prendo username e password e le metto nel back
	setPrefs();
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	new_version_badge.style.display = 'none';
	
	resizedWhenFlippedOver = false;
	if (window.widget)
	{	
		resizedWhenFlippedOver = true;
		window.resizeTo (210, 178);
		
		widget.prepareForTransition("ToBack");
	}
	
	front.style.display="none";
	back.style.display="block";
		
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    // se le preferenze sono state modificate devo rifare l'update dei dati
	if (((document.getElementById("input_username").value) != (widget.preferenceForKey("username"))) || password_changed) {prefs_changed = true;}
	savePrefs();
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	resizedWhenFlippedOver = false;
	if (window.widget)
	{	
		//resizedWhenFlippedOver = true;
		//window.resizeTo (170, 116);
		//non rimpicciolisco!
		
		widget.prepareForTransition("ToFront");
	}
	
	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout("widget.performTransition();", 0);
	
	if (there_is_a_new_version) new_version_badge.style.display = 'block';
	
	if (prefs_changed) {
		try{clearTimeout(nextUpdate);} catch(ex){}
		getData();
	}
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

function goToMySite()
{
	// vai al sito
	widget.openURL("http://www.palple.net/widgets/dashsense/index.html");
}

//************ version check **************************************

function goToDownloadPage()
{
	// vai al sito
	widget.openURL("http://www.palple.net/widgets/dashsense/dashSense.zip");
}

var version_req_stop_timeout = false;
var version_req_timeout = false;

function loadVersionPage(url)
{
	if (window.XMLHttpRequest) {
		version_req = new XMLHttpRequest();
		version_req.onreadystatechange = parseVersionPage;
		version_req.overrideMimeType("text/xml");
		version_req.setRequestHeader("Cache-Control", "no-cache")
		version_req.open("GET", url, true);
		version_req.send(null);
		
		version_req_stop_timeout = false;
		version_req_timeout = false;
		setTimeout("version_req_send_timeout();",5000);
	}
}

function version_req_send_timeout()
{
	if (version_req_stop_timeout){return;}
	version_req_timeout = true;
}

function isGreaterVersion(release1, release2)
{
	// faccio uno split per il '.' e poi verifico valore per valore
	release1_numbers = release1.split('.');
	release2_numbers = release2.split('.');
	
	release1_value = 0;
	release2_value = 0;
	
	// risolvo matematicamente che  pi elegante...
	
	for (var i=0;i<release1_numbers.length;i++){
		release1_value += release1_numbers[i]*(Math.pow(10,-i*3));
	}
	
	for (var i=0;i<release2_numbers.length;i++){
		release2_value += release2_numbers[i]*(Math.pow(10,-i*3));
	}
	
	if (release1_value > release2_value) return true;
	
	return false;
}

function parseVersionPage()
{
	if (version_req_timeout) {version_req.abort(); version_req_timeout = false; version_req_stop_timeout = true; return;}
	
	if ((version_req.readyState == 4) && (version_req.status == 200)) {
		version_req_stop_timeout = true;
		version_req_timeout = false;
		
		latest_version = version_req.responseXML.getElementsByTagName("version");
		latest_version = latest_version[0].firstChild.data;
		
		// faccio una comparazione tra versioni
		if (isGreaterVersion(latest_version,current_version)){
			there_is_a_new_version = true;
		}
		
		/*
		if (latest_version != current_version){
			there_is_a_new_version = true;
		}*/
		//debug (latest_version);
		
		if (there_is_a_new_version) {
			new_version_badge.style.display = "block"
			new_version_tooltip_string = getLocalizedString('new_version_tooltip') + " " + latest_version + " (" + getLocalizedString('you_have') + " " + current_version + ")";
			new_version_badge.setAttribute ("title", new_version_tooltip_string);
		}
	}
}

function version_check()
{
	loadVersionPage('http://www.palple.net/widgets/dashsense/version.xml');
}

function goToDonate()
{
	widget.openURL("http://www.palple.net/widgets/dashsense/index.html#donate");
}

function goToHelp()
{
 	widget.openURL("http://www.palple.net/widgets/dashsense/help.html");
}